unit uBizPedidosClienteServer;

interface

uses
  schPedidosClienteServer_Intf, uDAInterfaces,
  uDADataTable, uDABusinessProcessor;

const
  BIZ_SERVER_PEDIDOS_CLIENTE = 'Server.PedidosCliente';
  REF_PEDIDOS_CLIENTE = 'REF_PEDIDOS_CLIENTE';

type
  TBizPedidosClienteServer = class(TPedidosClienteBusinessProcessorRules)
  protected
    procedure BeforeProcessChange(Sender: TDABusinessProcessor;
      aChangeType: TDAChangeType; aChange: TDADeltaChange;
      var ProcessChange: Boolean); override;
  end;

implementation

uses
  Dialogs, SysUtils, Variants, uDataModuleServer, uDAClasses, DARemoteService_Impl,
  schPedidosClienteClient_Intf, uBusinessUtils, uReferenciasUtils, uROClasses;

{ TBizPedidosClienteServer }

procedure TBizPedidosClienteServer.BeforeProcessChange(
  Sender: TDABusinessProcessor; aChangeType: TDAChangeType;
  aChange: TDADeltaChange; var ProcessChange: Boolean);
var
  ASchema : TDASchema;
  ACurrentConn : IDAConnection;
  dsData: IDADataset;
  Empresa : Variant;

begin
  inherited;
  case aChangeType of
    ctInsert, ctUpdate: begin
      //Si la referencia no ha sido asignada le asignamos una nosotros
      if (VarIsNull(aChange.NewValueByName[fld_PedidosClienteREFERENCIA]))
      or (VarToStr(aChange.NewValueByName[fld_PedidosClienteREFERENCIA]) = '') then
      begin
        ASchema := BusinessProcessor.Schema;
        ACurrentConn := GetBusinessProcessorConnection(BusinessProcessor);

        try
          //Siempre va a estar rellena
          Empresa := aChange.NewValueByName[fld_PedidosClienteID_EMPRESA];
          dsData := ASchema.NewDataset(ACurrentConn, 'DarReferencia', ['CODIGO', 'ID_EMPRESA'], [REF_PEDIDOS_CLIENTE, Empresa]);
        except
          RaiseError('No existe la tabla REFERENCIAS');
        end;

        dsData.Active := True;

        if dsData.IsEmpty then
          RaiseError('NO HAY REFERENCIA ' + REF_PEDIDOS_CLIENTE + ' DECLARADA EN TABLA REFERENCIAS');

        REFERENCIA := dsData.FieldByName(fld_DarReferenciaVALOR).AsString;

        try
          ASchema.NewCommand(ACurrentConn, 'ModificarReferencia', ['CODIGO', 'VALOR', 'ID_EMPRESA'], [REF_PEDIDOS_CLIENTE, DarReferenciaSiguiente(REFERENCIA), Empresa]);
        except
          RaiseError('Error al asignar la nueva ' + REFERENCIA + ' referencia en tabla');
        end;

      end;
    end;
  end;
end;

initialization
  RegisterBusinessProcessorRules(BIZ_SERVER_PEDIDOS_CLIENTE, TBizPedidosClienteServer);

end.
